<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" 
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
    xmlns:fn="http://www.pageseeder.com/function">
    
  <xsl:template name="apply-style">
    <xsl:variable name="stylename">
      <xsl:choose>
        <xsl:when test="name()='para' and parent::paraLabel">
          <xsl:value-of select="concat('ps-paralabel-',parent::paraLabel/@name)"/>
        </xsl:when>
        <xsl:when test="name()='para'">para</xsl:when>
        <xsl:when test="ancestor::inlineLabel">
          <xsl:value-of select="concat('ps-inlinelabel-',ancestor::inlineLabel[1]/@name)"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="if (name()='paraLabel')                   then concat('ps-paralabel-',@name)
                           else if (starts-with(name(),'heading'))        then replace(name(),'heading','heading ')
		                       else if (self::text() and ancestor::monospace) then 'monospace'
		                       else name()"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="allStyles" select="document(replace($stylemapping, ' ', '%20'))/styles" />
        
    <xsl:choose>
	    <xsl:when test="fn:elementType(name())='block' and $allStyles/style[@name=$stylename]/@id" >
        <w:pStyle w:val="{$allStyles/style[@name=$stylename]/@id}"/>
      </xsl:when>
      <xsl:when test="fn:elementType(name())='block'" >
        <w:pStyle w:val="Normal"/>
      </xsl:when>
      <xsl:when test="fn:elementType(name())='inline' and $allStyles/style[@name=$stylename]/@id">
        <w:rStyle w:val="{$allStyles/style[@name=$stylename]/@id}"/>
      </xsl:when>
	    <xsl:when test="fn:elementType(name())='inline'">
        <w:rStyle w:val="DefaultParagraphFont"/>
      </xsl:when>
	    <xsl:when test="fn:elementType(name())='table' and $allStyles/style[@name=$stylename]/@id">
        <w:tblStyle w:val="{$allStyles/style[@name=$stylename]/@id}"/>
      </xsl:when>
    </xsl:choose>
  </xsl:template>
    
</xsl:stylesheet>